/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package test;

import java.io.IOException;
import java.io.Serializable;
import org.infinispan.Cache;
import org.infinispan.manager.CacheManager;
import org.junit.Assert;
import org.junit.Test;

/**
 *
 */
public class TestReplace {

    public static class TestKey implements Serializable {

        private String name;

        public TestKey(String name) {
            this.name = name;
        }

        @Override
        public boolean equals(Object obj) {
            System.out.println(obj.getClass());
            if (obj == null) {
                System.out.println("null -> false");
                return false;

            }
            if (getClass() != obj.getClass()) {
                System.out.println("class not same -> false");
                return false;
            }
            final TestKey other = (TestKey) obj;
            return this.name.equals(other.name);
        }

        @Override
        public int hashCode() {
            return name.hashCode();
        }

    }
/*
    @Test
    public void testReplace() throws IOException {
        CacheManager cacheManager = new org.infinispan.manager.DefaultCacheManager("test-cluster.xml");

        Cache cache = cacheManager.getCache("TEST_CACHE");

        TestKey key = new TestKey("hello");
        cache.put(key, "1");

        Assert.assertEquals("1", cache.get(new TestKey("hello")));
        Object oldValue= cache.replace(new TestKey("hello"), "2");
        Assert.assertEquals("1", oldValue);
        Assert.assertEquals("2", cache.get(new TestKey("hello")));
    }
*/
    @Test
    public  void testReplaceWithOldValue() throws IOException{
        CacheManager cacheManager = new org.infinispan.manager.DefaultCacheManager("test-cluster.xml");

        Cache cache = cacheManager.getCache("TEST_CACHE");
        TestKey value1 = new TestKey("value1");
        cache.put("a",value1);

        value1 = new TestKey("value1"); 
        TestKey newValue = new TestKey("value2");
        Assert.assertTrue(cache.replace("a",value1, newValue));
    
        
    }
}
